%global __provides_exclude_from ^%{_libdir}/pmdk_debug/.*\\.so.*$
%global common_description_v1 %{expand:
The libpmem provides low level persistent memory support. In particular, support for the
persistent memory instructions for flushing changes to pmem is provided.
This package provides the v1 API.}

%global common_description_v2 %{expand:
The libpmem provides low level persistent memory support. In particular, support for the
persistent memory instructions for flushing changes to pmem is provided.
This package provides the v2 API.}

Summary:       Persistent Memory Development Kit (formerly NVML)
Name:          nvml
Version:       1.12.1
Release:       8%{?dist}
License:       BSD
URL:           http://pmem.io/pmdk
Source0:       https://github.com/pmem/pmdk/releases/download/%{version}/pmdk-%{version}.tar.gz
Source1:       testconfig.sh
Source2:       testconfig.py
Patch5000:     0001-nvml-fix-build-for-groff-1.23.0.patch
Patch5001:     0001-pmdk-1.12.1-add-support-for-loongarch64.patch

BuildRequires: gcc make glibc-devel autoconf automake man pkgconfig
BuildRequires: python3 groff cmake gdb bc libunwind-devel
BuildRequires: ndctl-devel daxctl-devel ndctl libfabric-devel

ExclusiveArch: x86_64 ppc64le loongarch64

%description
The Persistent Memory Development Kit is a collection of libraries for using memory-mapped
persistence, optimized specifically for persistent memory.

%package -n libpmem
Summary: Low-level persistent memory support library

%description -n libpmem
%{common_description_v1}

%package -n libpmem-devel
Summary: Development files for the low-level persistent memory library
Requires: libpmem = %{version}-%{release}

%description -n libpmem-devel
%{common_description_v1}

This library is provided for software which tracks every store to pmem and needs to flush
those changes to durability. Most developers will find higher level libraries like libpmemobj
to be much more convenient.

%package -n libpmem-debug
Summary: Debug variant of the low-level persistent memory library
Requires: libpmem = %{version}-%{release}

%description -n libpmem-debug
%{common_description_v1}

This sub-package contains debug variant of the library, providing run-time assertions and
trace points. The typical way to access the debug version is to set the environment variable
LD_LIBRARY_PATH to /usr/lib64/pmdk_debug.

%package -n libpmem2
Summary: Low-level persistent memory support library

%description -n libpmem2
%{common_description_v2}

%package -n libpmem2-devel
Summary: Development files for the low-level persistent memory library
Requires: libpmem = %{version}-%{release}

%description -n libpmem2-devel
%{common_description_v2}

This library is provided for software which tracks every store to pmem and needs to flush
those changes to durability. Most developers will find higher level libraries like libpmemobj
to be much more convenient.


%package -n libpmem2-debug
Summary: Debug variant of the low-level persistent memory library
Requires: libpmem = %{version}-%{release}

%description -n libpmem2-debug
%{common_description_v2}

This sub-package contains debug variant of the library, providing run-time assertions and
trace points. The typical way to access the debug version is to set the environment
variable LD_LIBRARY_PATH to /usr/lib64/pmdk_debug.

%package -n libpmemblk
Summary: Persistent Memory Resident Array of Blocks library
Requires: libpmem >= %{version}-%{release}

%description -n libpmemblk
The libpmemblk implements a pmem-resident array of blocks, all the same size, where a block
is updated atomically with respect to power failure or program interruption (no torn blocks).

%package -n libpmemblk-devel
Summary: Development files for the Persistent Memory Resident Array of Blocks library
Requires: libpmemblk = %{version}-%{release}
Requires: libpmem-devel = %{version}-%{release}

%description -n libpmemblk-devel
The libpmemblk implements a pmem-resident array of blocks, all the same size, where a block
is updated atomically with respect to power failure or program interruption (no torn blocks).

For example, a program keeping a cache of fixed-size objects in pmem might find this library
useful. This library is provided for cases requiring large arrays of objects at least 512 bytes each.
Most developers will find higher level libraries like libpmemobj to be more generally useful.

%package -n libpmemblk-debug
Summary: Debug variant of the Persistent Memory Resident Array of Blocks library
Requires: libpmemblk = %{version}-%{release}

%description -n libpmemblk-debug
The libpmemblk implements a pmem-resident array of blocks, all the same size, where a block is
updated atomically with respect to power failure or program interruption (no torn blocks).

This sub-package contains debug variant of the library, providing run-time assertions and trace points.
The typical way to access the debug version is to set the environment variable LD_LIBRARY_PATH to
/usr/lib64/pmdk_debug.

%package -n libpmemlog
Summary: Persistent Memory Resident Log File library
Requires: libpmem >= %{version}-%{release}

%description -n libpmemlog
The libpmemlog library provides a pmem-resident log file. This is useful for programs like databases
that append frequently to a log file.

%package -n libpmemlog-devel
Summary: Development files for the Persistent Memory Resident Log File library
Requires: libpmemlog = %{version}-%{release}
Requires: libpmem-devel = %{version}-%{release}

%description -n libpmemlog-devel
The libpmemlog library provides a pmem-resident log file. This library is provided for cases requiring
an append-mostly file to record variable length entries. Most developers will find higher level libraries
like libpmemobj to be more generally useful.

%package -n libpmemlog-debug
Summary: Debug variant of the Persistent Memory Resident Log File library
Requires: libpmemlog = %{version}-%{release}

%description -n libpmemlog-debug
The libpmemlog library provides a pmem-resident log file. This library is provided for cases requiring
an append-mostly file to record variable length entries. Most developers will find higher level libraries
like libpmemobj to be more generally useful.

This sub-package contains debug variant of the library, providing run-time assertions and trace points.
The typical way to access the debug version is to set the environment variable LD_LIBRARY_PATH to
/usr/lib64/pmdk_debug.

%package -n libpmemobj
Summary: Persistent Memory Transactional Object Store library
Requires: libpmem >= %{version}-%{release}

%description -n libpmemobj
The libpmemobj library provides a transactional object store, providing memory allocation, transactions,
and general facilities for persistent memory programming.

%package -n libpmemobj-devel
Summary: Development files for the Persistent Memory Transactional Object Store library
Requires: libpmemobj = %{version}-%{release}
Requires: libpmem-devel = %{version}-%{release}

%description -n libpmemobj-devel
The libpmemobj library provides a transactional object store, providing memory allocation, transactions,
and general facilities for persistent memory programming. Developers new to persistent memory probably
want to start with this library.

%package -n libpmemobj-debug
Summary: Debug variant of the Persistent Memory Transactional Object Store library
Requires: libpmemobj = %{version}-%{release}

%description -n libpmemobj-debug
The libpmemobj library provides a transactional object store, providing memory allocation, transactions,
and general facilities for persistent memory programming. Developers new to persistent memory probably
want to start with this library.

This sub-package contains debug variant of the library, providing run-time assertions and trace points.
The typical way to access the debug version is to set the environment variable LD_LIBRARY_PATH to
/usr/lib64/pmdk_debug.

%package -n libpmempool
Summary: Persistent Memory pool management library
Requires: libpmem >= %{version}-%{release}

%description -n libpmempool
The libpmempool library provides a set of utilities for off-line administration, analysis, diagnostics and
repair of persistent memory pools created by libpmemlog, libpmemblk and libpmemobj libraries.

%package -n libpmempool-devel
Summary: Development files for Persistent Memory pool management library
Requires: libpmempool = %{version}-%{release}
Requires: libpmem-devel = %{version}-%{release}

%description -n libpmempool-devel
The libpmempool library provides a set of utilities for off-line administration, analysis, diagnostics and
repair of persistent memory pools created by libpmemlog, libpmemblk and libpmemobj libraries.

%package -n libpmempool-debug
Summary: Debug variant of the Persistent Memory pool management library
Requires: libpmempool = %{version}-%{release}

%description -n libpmempool-debug
The libpmempool library provides a set of utilities for off-line administration, analysis, diagnostics and
repair of persistent memory pools created by libpmemlog, libpmemblk and libpmemobj libraries.

This sub-package contains debug variant of the library, providing run-time assertions and trace points.
The typical way to access the debug version is to set the environment variable LD_LIBRARY_PATH to
/usr/lib64/pmdk_debug.


%package -n librpmem
Summary: Remote Access to Persistent Memory library
Requires: libfabric
Requires: openssh-clients

%description -n librpmem
The librpmem library provides low-level support for remote access to persistent memory utilizing RDMA-capable
NICs. It can be used to replicate persistent memory regions over RDMA protocol.

%package -n librpmem-devel
Summary: Development files for the Remote Access to Persistent Memory library
Requires: librpmem = %{version}-%{release}

%description -n librpmem-devel
The librpmem library provides low-level support for remote access to persistent memory utilizing RDMA-capable
NICs. It can be used to replicate persistent memory regions over RDMA protocol.

This sub-package contains libraries and header files for developing
applications that want to specifically make use of librpmem.

%package -n librpmem-debug
Summary: Debug variant of the Remote Access to Persistent Memory library
Requires: librpmem = %{version}-%{release}

%description -n librpmem-debug
The librpmem library provides low-level support for remote access to persistent memory utilizing RDMA-capable
NICs. It can be used to replicate persistent memory regions over RDMA protocol.

This sub-package contains debug variant of the library, providing run-time assertions and trace points.
The typical way to access the debug version is to set the environment variable LD_LIBRARY_PATH to
/usr/lib64/pmdk_debug.

%package -n rpmemd
Summary: Target node process executed by librpmem
Requires: libfabric

%description -n rpmemd
The rpmemd process is executed on a target node by librpmem library and facilitates access to persistent memory over RDMA.

%package -n pmempool
Summary: Utilities for Persistent Memory
Requires: libpmem >= %{version}-%{release}
Requires: libpmemlog >= %{version}-%{release}
Requires: libpmemblk >= %{version}-%{release}
Requires: libpmemobj >= %{version}-%{release}
Requires: libpmempool >= %{version}-%{release}

%description -n pmempool
The pmempool is a standalone utility for management and off-line analysis of Persistent Memory pools created by PMDK
libraries. It provides a set of utilities for administration and diagnostics of Persistent Memory pools.
The pmempool may be useful for troubleshooting by system administrators and users of the applications based on PMDK libraries.


%package -n daxio
Summary: Perform I/O on Device DAX devices or zero a Device DAX device
Requires: libpmem >= %{version}-%{release}

%description -n daxio
The daxio utility performs I/O on Device DAX devices or zero a Device DAX device.  Since the standard I/O APIs
(read/write) cannot be used with Device DAX, data transfer is performed on a memory-mapped device. The daxio may be
used to dump Device DAX data to a file, restore data from a backup copy, move/copy data to another device or to erase
data from a device.

%package -n pmreorder
Summary: Consistency Checker for Persistent Memory
Requires: python3

%description -n pmreorder
The pmreorder tool is a collection of python scripts designed to parse and replay operations logged by
pmemcheck - a persistent memory checking tool. Pmreorder performs the store reordering between persistent
memory barriers - a sequence of flush-fence operations. It uses a consistency checking routine
provided in the command line options to check whether files are in a consistent state.

%prep
%autosetup -n pmdk-%{version} -p1
cp %{SOURCE1} src/test/
cp %{SOURCE2} src/test/

%build
%define _lto_cflags %{nil}

CFLAGS="%{optflags}" \
LDFLAGS="%{?__global_ldflags}" \
%make_build NORPATH=1

%install
%make_install \
    LIB_AR= \
    prefix=%{_prefix} \
    libdir=%{_libdir} \
    includedir=%{_includedir} \
    mandir=%{_mandir} \
    bindir=%{_bindir} \
    sysconfdir=%{_sysconfdir} \
    docdir=%{_docdir}
mkdir -p %{buildroot}%{_datadir}/pmdk
cp utils/pmdk.magic %{buildroot}%{_datadir}/pmdk/

%check
rm -f src/test/obj_sync/TEST7
rm -f src/test/pmemset*/TEST*
rm -f src/test/rpmemd_dbg/TEST*
rm -f src/test/rpmemd_log/TEST*
rm -f src/test/obj_zones/TEST*
rm -f src/test/obj_ctl_arenas/TEST3 src/test/pmem2_future/TESTS.py

make pycheck
make check

%files -n libpmem
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_datadir}/pmdk
%{_libdir}/libpmem.so.*
%{_datadir}/pmdk/pmdk.magic

%files -n libpmem-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmem.so
%{_libdir}/pkgconfig/libpmem.pc
%{_includedir}/libpmem.h
%{_mandir}/man7/libpmem.7.gz
%{_mandir}/man3/pmem_*.3.gz
%{_mandir}/man5/pmem_ctl.5.gz

%files -n libpmem-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/libpmem.so
%{_libdir}/pmdk_debug/libpmem.so.*

%files -n libpmem2
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_datadir}/pmdk
%{_libdir}/libpmem2.so.*

%files -n libpmem2-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmem2.so
%{_libdir}/pkgconfig/libpmem2.pc
%{_includedir}/libpmem2.h
%{_includedir}/libpmem2/*.h
%{_mandir}/man7/libpmem2*7.gz
%{_mandir}/man3/pmem2_*.3.gz

%files -n libpmem2-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/libpmem2.so
%{_libdir}/pmdk_debug/libpmem2.so.*

%files -n libpmemblk
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmemblk.so.*

%files -n libpmemblk-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmemblk.so
%{_libdir}/pkgconfig/libpmemblk.pc
%{_includedir}/libpmemblk.h
%{_mandir}/man7/libpmemblk.7.gz
%{_mandir}/man5/poolset.5.gz
%{_mandir}/man3/pmemblk_*.3.gz

%files -n libpmemblk-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/libpmemblk.so
%{_libdir}/pmdk_debug/libpmemblk.so.*

%files -n libpmemlog
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmemlog.so.*

%files -n libpmemlog-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmemlog.so
%{_libdir}/pkgconfig/libpmemlog.pc
%{_includedir}/libpmemlog.h
%{_mandir}/man7/libpmemlog.7.gz
%{_mandir}/man5/poolset.5.gz
%{_mandir}/man3/pmemlog_*.3.gz

%files -n libpmemlog-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/libpmemlog.so
%{_libdir}/pmdk_debug/libpmemlog.so.*

%files -n libpmemobj
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmemobj.so.*

%files -n libpmemobj-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmemobj.so
%{_libdir}/pkgconfig/libpmemobj.pc
%{_includedir}/libpmemobj.h
%dir %{_includedir}/libpmemobj
%{_includedir}/libpmemobj/*.h
%{_mandir}/man7/libpmemobj.7.gz
%{_mandir}/man5/poolset.5.gz
%{_mandir}/man3/pmemobj_*.3.gz
%{_mandir}/man3/pobj_*.3.gz
%{_mandir}/man3/oid_*.3.gz
%{_mandir}/man3/toid*.3.gz
%{_mandir}/man3/direct_*.3.gz
%{_mandir}/man3/d_r*.3.gz
%{_mandir}/man3/tx_*.3.gz

%files -n libpmemobj-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/libpmemobj.so
%{_libdir}/pmdk_debug/libpmemobj.so.*

%files -n libpmempool
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmempool.so.*

%files -n libpmempool-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/libpmempool.so
%{_libdir}/pkgconfig/libpmempool.pc
%{_includedir}/libpmempool.h
%{_mandir}/man7/libpmempool.7.gz
%{_mandir}/man5/poolset.5.gz
%{_mandir}/man3/pmempool_*.3.gz

%files -n libpmempool-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/libpmempool.so
%{_libdir}/pmdk_debug/libpmempool.so.*

%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%files -n librpmem
%{_libdir}/librpmem.so.*

%files -n librpmem-devel
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_libdir}/librpmem.so
%{_libdir}/pkgconfig/librpmem.pc
%{_includedir}/librpmem.h
%{_mandir}/man7/librpmem.7.gz
%{_mandir}/man3/rpmem_*.3.gz

%files -n librpmem-debug
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%dir %{_libdir}/pmdk_debug
%{_libdir}/pmdk_debug/librpmem.so
%{_libdir}/pmdk_debug/librpmem.so.*

%files -n rpmemd
%{_bindir}/rpmemd
%{_mandir}/man1/rpmemd.1.gz

%files -n pmempool
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_bindir}/pmempool
%{_mandir}/man1/pmempool.1.gz
%{_mandir}/man1/pmempool-*.1.gz
%config(noreplace) %{_sysconfdir}/bash_completion.d/pmempool

%files -n daxio
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_bindir}/daxio
%{_mandir}/man1/daxio.1.gz

%files -n pmreorder
%license LICENSE
%doc ChangeLog CONTRIBUTING.md README.md
%{_bindir}/pmreorder
%{_datadir}/pmreorder/*.py
%{_mandir}/man1/pmreorder.1.gz

%changelog
* Sat May 11 2024 Pengda Dou <doupengda@loongson.cn> - 1.12.1-8
- [Type] other
- [DESC] add support for loongarch64

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.12.1-7
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 1.12.1-6
- Rebuilt for ndctl 78

* Fri Aug 11 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.12.1-5
- Fix some wrong removals

* Thu Aug 10 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.12.1-4
- Fix build for groff 1.23.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.12.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.12.1-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 28 2022 Shuo Wang <abushwang@tencent.com> - 1.12.1-1
- initial build
